## org.apache.mahout.math
Class UpperTriangular

    java.lang.Object
      org.apache.mahout.math.AbstractMatrix
          org.apache.mahout.math.UpperTriangular

All Implemented Interfaces:
  Cloneable, Iterable<MatrixSlice>, Matrix, VectorIterable

Direct Known Subclasses:
  DenseSymmetricMatrix

    public class UpperTriangular

extends AbstractMatrix

Quick and dirty implementation of some `Matrix` methods over packed upper triangular matrix.

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.mahout.math.AbstractMatrix
`AbstractMatrix.TransposeViewVector`

Field Summary

Fields inherited from class org.apache.mahout.math.AbstractMatrix
`COL, columnLabelBindings, columns, ROW, rowLabelBindings, rows`

Constructor Summary
`UpperTriangular(double[] data, boolean shallow)`
`UpperTriangular(int n)` represents n x n upper triangular matrix
`UpperTriangular(UpperTriangular mx)`
`UpperTriangular(Vector data)`

Method Summary
`Matrix` `assignColumn(int column, Vector other)` Assign the other vector values to the column of the receiver
`Matrix` `assignNonZeroElementsInRow(int row, double[] other)`
`Matrix` `assignRow(int row, Vector other)` Assign the other vector values to the row of the receiver
`double[]` `getData()`
`int[]` `getNumNondefaultElements()` Return the number of values in the recipient
`double` `getQuick(int row, int column)` Return the value at the given indexes, without checking bounds
`Matrix` `like()` Return an empty matrix of the same underlying class as the receiver
`Matrix` `like(int rows, int columns)` Returns an empty matrix of the same underlying class as the receiver and of the specified size.
`void` `setQuick(int row, int column, double value)` Set the value at the given index, without checking bounds
`Matrix` `viewPart(int[] offset, int[] size)` Return a view into part of a matrix.

Methods inherited from class org.apache.mahout.math.AbstractMatrix

`aggregate, aggregateColumns, aggregateRows, asFormatString, assign, assign, assign, assign, assign, clone, columnSize, determinant, divide, get, get, getColumnLabelBindings, getRowLabelBindings, iterateAll, iterator, minus, numCols, numRows, numSlices, plus, plus, rowSize, set, set, set, set, set, set, setColumnLabelBindings, setRowLabelBindings, times, times, times, timesSquared, toString, transpose, viewColumn, viewDiagonal, viewPart, viewRow, zSum`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### UpperTriangular

    public UpperTriangular(int n)

  represents n x n upper triangular matrix

  Parameters:
    `n` -

### UpperTriangular

    public UpperTriangular(double[] data,
                           boolean shallow)

### UpperTriangular

    public UpperTriangular(Vector data)

### UpperTriangular

    public UpperTriangular(UpperTriangular mx)

Method Detail

### assignColumn

    public Matrix assignColumn(int column,
                               Vector other)

  Description copied from interface: `Matrix`
  Assign the other vector values to the column of the receiver

  Parameters:
    `column` - the int row to assign
    `other` - a Vector
  Returns:
    the modified receiver

### assignRow

    public Matrix assignRow(int row,
                            Vector other)

  Description copied from interface: `Matrix`
  Assign the other vector values to the row of the receiver

  Parameters:
    `row` - the int row to assign
    `other` - a Vector
  Returns:
    the modified receiver

### assignNonZeroElementsInRow

    public Matrix assignNonZeroElementsInRow(int row,
                                             double[] other)

### getQuick

    public double getQuick(int row,
                           int column)

  Description copied from interface: `Matrix`
  Return the value at the given indexes, without checking bounds

  Parameters:
    `row` - an int row index
    `column` - an int column index
  Returns:
    the double at the index

### like

    public Matrix like()

  Description copied from interface: `Matrix`
  Return an empty matrix of the same underlying class as the receiver

  Returns:
    a Matrix

### like

    public Matrix like(int rows,
                       int columns)

  Description copied from interface: `Matrix`
  Returns an empty matrix of the same underlying class as the receiver and of the specified size.

  Parameters:
    `rows` - the int number of rows
    `columns` - the int number of columns

### setQuick

    public void setQuick(int row,
                         int column,
                         double value)

  Description copied from interface: `Matrix`
  Set the value at the given index, without checking bounds

  Parameters:
    `row` - an int row index into the receiver
    `column` - an int column index into the receiver
    `value` - a double value to set

### getNumNondefaultElements

    public int[] getNumNondefaultElements()

  Description copied from interface: `Matrix`
  Return the number of values in the recipient

  Specified by:
    `getNumNondefaultElements` in interface `Matrix`
  Overrides:
    `getNumNondefaultElements` in class `AbstractMatrix`
  Returns:
    an int[2] containing [row, column] count

### viewPart

    public Matrix viewPart(int[] offset,
                           int[] size)

  Description copied from interface: `Matrix`
  Return a view into part of a matrix. Changes to the view will change the original matrix.

  Specified by:
    `viewPart` in interface `Matrix`
  Overrides:
    `viewPart` in class `AbstractMatrix`
  Parameters:
    `offset` - an int[2] offset into the receiver
    `size` - the int[2] size of the desired result
  Returns:
    a matrix that shares storage with part of the original matrix.

### getData

    public double[] getData()

Copyright © 2008–2014 The Apache Software Foundation. All rights reserved.